import { RawClientSideBasePluginConfig } from 'webql-codegen-visitor-plugin-common';
/**
 * @description This plugin generates Stencil Apollo functional components typings
 *
 * It extends the basic TypeScript plugins: `webql-codegen-typescript`, `webql-codegen-typescript-operations` - and thus shares a similar configuration.
 */
export interface StencilApolloRawPluginConfig extends RawClientSideBasePluginConfig {
    /**
     * @description Customize the output of the plugin - you can choose to generate a Component class or a function component.
     * @default functional
     *
     * @exampleMarkdown
     * ```yml
     * generates:
     * path/to/file.ts:
     *  plugins:
     *    - typescript
     *    - typescript-operations
     *    - typescript-stencil-apollo
     *  config:
     *    componentType: class
     * ```
     */
    componentType?: StencilComponentType;
}
export declare enum StencilComponentType {
    functional = "functional",
    class = "class"
}
